
#include <propeller.h>
#include "dc_motor.h"

static volatile char _RATE = 0;
static int Stack[40 + 16];




DCMotor::DCMotor(char Pin)
{
  pin = Pin;
  mask = 1<<pin;

  OUTA &= ~mask;  // set low
  DIRA |= mask;   // set as output

  cogstart( &StartThread, this, Stack, sizeof(Stack) );
}

void DCMotor::run(uint8_t value)
{
  if( value == rate ) return;
  rate = value;

  /*
  if( rate == 0 ) {
    // turn off the PWM
    CTRA = 0; // off
  }
  else {
    // turn on the PWM
    CTRA = (6 << 26) | pin; // duty mode
    FRQA = (value << 24) | (value << 16) | (value << 8) | value;
  }
  */
}

void DCMotor::StartThread( void * param )
{
  ((DCMotor *)param)->PwmThread();
}

void DCMotor::PwmThread(void)
{
  OUTA &= ~mask;  // set low
  DIRA |= mask;   // set as output

  while(true)
  {
    char tempRate = rate;
    if( tempRate ) {
      OUTA |= mask;
      waitcnt( (tempRate << 7) + 24 + CNT );
      OUTA &= ~mask;
    }

    tempRate = 255-tempRate;
    if( tempRate ) {
      waitcnt( (tempRate << 7) + 24 + CNT );
    }
  }
}
